Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# MD5MAC_Base Class Reference

`#include <md5mac.h>`

Inheritance diagram for MD5MAC_Base:

List of all members.

## Detailed Description

Definition at line 13 of file md5mac.h.

## Public Types
enum | { DIGESTSIZE = 16 }
typedef LittleEndian | ByteOrderClass
typedef IteratedHashBase< word32, MessageAuthenticationCode >::HashWordType | HashWordType
enum | IV_Requirement { STRUCTURED_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
void | UncheckedSetKey (const byte *userKey, unsigned int keylength)
void | TruncatedFinal (byte *mac, unsigned int size)
| truncated version of Final()
unsigned int | DigestSize () const
unsigned int | OptimalBlockSize () const
void | Update (const byte *input, unsigned int length)
byte * | CreateUpdateSpace (unsigned int &size)
void | Restart ()
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | CalculateDigest (byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, unsigned int digestSize, const byte *input, unsigned int length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, unsigned int digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, unsigned int digestLength, const byte *input, unsigned int length)
| truncated version of VerifyDigest()
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
virtual unsigned int | MinKeyLength () const=0
| returns smallest valid key length in bytes */
virtual unsigned int | MaxKeyLength () const=0
| returns largest valid key length in bytes */
virtual unsigned int | DefaultKeyLength () const=0
| returns default (recommended) key length in bytes */
virtual unsigned int | GetValidKeyLength (unsigned int n) const=0
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
virtual bool | IsValidKeyLength (unsigned int n) const
| returns whether n is a valid key length
virtual void | SetKey (const byte *key, unsigned int length, const NameValuePairs &params=g_nullNameValuePairs)=0
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, unsigned int length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, unsigned int length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
virtual IV_Requirement | IVRequirement () const=0
| returns the minimal requirement for secure IVs
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
| returns size of IVs used by this object
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (byte *IV)
| get a secure IV for the next message
## Static Public Member Functions
std::string | StaticAlgorithmName ()
unsigned int | StaticGetValidKeyLength (unsigned int)
void | CorrectEndianess (HashWordType *out, const HashWordType *in, unsigned int byteCount)
## Protected Member Functions
void | vTransform (const word32 *data)
void | Init ()
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
void | HashBlock (const HashWordType *input)
virtual void | HashBlock (const word32 *input)=0
virtual void | vTransform (const HashWordType *data)=0
word32 | GetBitCountHi () const
word32 | GetBitCountLo () const
virtual unsigned int | HashMultipleBlocks (const word32 *input, unsigned int length)
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
void | ThrowIfInvalidTruncatedSize (unsigned int size) const
void | ThrowIfInvalidKeyLength (const Algorithm &algorithm, unsigned int length)
void | AssertValidKeyLength (unsigned int length) const
## Static Protected Member Functions
void | Transform (word32 *buf, const word32 *in, const word32 *key)
## Protected Attributes
FixedSizeSecBlock< word32, 12 > | m_key
SecBlock< word32 > | m_data
SecBlock< word32 > | m_digest
## Static Protected Attributes
const word32 | T [12]

## Member Function Documentation

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

| compute hash for current message, then restart for a new message Precondition: size of digest == DigestSize(). Reimplemented in PKCS_DecoratedHashModule< H >, SignatureEncodingMethodWithRecovery, and EMSA2DecoratedHashModule< H >. Definition at line 526 of file cryptlib.h. Referenced by HashFilter::Put2(), PK_SignerBase< H >::SignAndRestart(), and PK_VerifierBase< H >::VerifyAndRestart().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

| verify that digest is a valid digest for the current message, then reinitialize the object Default implementation is to call Final() and do a bitwise comparison between its output and digest. Reimplemented in SignatureEncodingMethodWithRecovery. Definition at line 549 of file cryptlib.h. Referenced by VerifierWithRecoveryTemplate< TF, H >::VerifyAndRestart().

virtual void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params = g_nullNameValuePairs
| ) | `[pure virtual, inherited]`

  | set or reset the key of this object Parameters:
  params | is used to specify Rounds, BlockSize, etc
Implemented in MessageAuthenticationCodeFinalTemplate< BASE, INFO >, MessageAuthenticationCodeFinalTemplate< HMAC_Base, HMAC< T > >, MessageAuthenticationCodeFinalTemplate< XMACC_Base< T > >, MessageAuthenticationCodeFinalTemplate< DMAC_Base< T > >, MessageAuthenticationCodeFinalTemplate< CBC_MAC_Base, CBC_MAC< T > >, MessageAuthenticationCodeFinalTemplate< HMAC_Base, HMAC< DefaultHashModule > >, and MessageAuthenticationCodeFinalTemplate< PanamaMAC_Base< B > >. Referenced by SimpleKeyingInterface::SetKeyWithIV(), and SimpleKeyingInterface::SetKeyWithRounds().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

| returns whether this object can be resynchronized (i.e. supports initialization vectors) If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed. Definition at line 381 of file cryptlib.h.

virtual void SimpleKeyingInterface::GetNextIV | ( | byte * | IV | ) | `[inline, virtual, inherited]`

| get a secure IV for the next message This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects. Definition at line 397 of file cryptlib.h.

## Member Data Documentation

const word32 MD5MAC_Base::T`[static, protected]`

| Initial value:
            { 0xac45ef97,0xcd430f29,0x551b7e45,0x3411801c,
              0x96ce77b1,0x7c8e722e,0x0aab5a5f,0x18be4336,
              0x21b4219d,0x4db987bc,0xbd279da2,0xc3d75bc7 }
Definition at line 10 of file md5mac.cpp.

The documentation for this class was generated from the following files:

- md5mac.h
- md5mac.cpp